﻿using System.Collections.Generic;
using System.Windows.Controls;
using Telerik.Windows.Controls.GridView;
using Telerik.Windows.Controls;
using System.Collections.ObjectModel;

namespace TestGrid
{
    public partial class MainPage : UserControl
    {
        private ObservableCollection<Person> dataSource;

        public MainPage()
        {
            InitializeComponent();

            this.dataSource = this.CreateDataSource();

            this.radGridView.ItemsSource = this.dataSource;

            this.radGridView.AddingNewDataItem += this.GridPersons_AddingNewDataItem;
        }

        private ObservableCollection<Person> CreateDataSource()
        {
            ObservableCollection<Person> persons = new ObservableCollection<Person>();
            for (int i = 0; i < 5; i++)
            {
                persons.Add(new Person
                {
                    FirstName = "John " + i, LastName = "Doe " + i
                });
            }
            return persons;
        }

        void GridPersons_AddingNewDataItem(object sender, GridViewAddingNewEventArgs e)
        {
            e.NewObject = new Person
            {
                FirstName = "Jane"
            };
        }

        private void Button_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            Person newPerson = new Person
            {
                FirstName = "Jane"
            };
            this.dataSource.Add(newPerson);
            this.radGridView.ScrollIntoViewAsync(newPerson, this.radGridView.Columns[1]
                , (f) =>
                {
                    GridViewRow row = f as GridViewRow;
                    if (row != null)
                    {
                        ((GridViewCell) row.Cells[1]).BeginEdit();
                    }
                }); 
        }

    }

    public class Person
    {
        public string FirstName
        {
            get;
            set;
        }
        public string LastName
        {
            get;
            set;
        }
    }
}
